#include <windows.h>
#include <process.h>    /* _beginthread, _endthread */

#include "tinygraphics.h"

#define APP_NAME TEXT("Of[V낤\tNo2")
#define MUTEX_NAME TEXT("Mutex")

HDC hMemDC;
HDC hTextDC;
HWND hWnd;
HBITMAP hBitmap;
HBITMAP hTextmap;

HANDLE hMutex;
int psetFlag;

TEXTMETRIC textMetrics;

void startup(void *dummy);

void clearText(void){
	Rectangle(hTextDC,0,0,XSIZE*PIXEL_SIZE,YSIZE*PIXEL_SIZE);

	InvalidateRect(hWnd , NULL , 0);
}

int myprintf(char *format){
#if 0
	static unsigned int lines = 0;
//	PAINTSTRUCT ps;
//	HDC hdc;

	TabbedTextOut(hTextDC,0,0,APP_NAME,lstrlen(APP_NAME),0,NULL,0);
	TabbedTextOut(hTextDC,0,textMetrics.tmHeight,APP_NAME,lstrlen(APP_NAME),0,NULL,0);
	
/*	hdc = BeginPaint(hTextDC,&ps);*/
	BitBlt(hTextDC,0,0,XSIZE*PIXEL_SIZE,YSIZE*PIXEL_SIZE-textMetrics.tmHeight,hTextDC,0,textMetrics.tmHeight,SRCCOPY);
/*	EndPaint(hWnd,&ps);*/
#endif
	return 0;
}

void pset(int x,int y,unsigned int r,unsigned int g,unsigned int b){
	HPEN hPen;
	HGDIOBJ hPObj;
#if PIXEL_SIZE > 2
	HBRUSH hBrush;
	HGDIOBJ hBObj;
#endif
	RECT rect;

	if(0x80000000&r){
		r = 0;
	}else if(r>255){
		r = 255;
	}
	if(0x80000000&g){
		g = 0;
	}else if(g > 255){
		g = 255;
	}
	if(0x80000000&b){
		b = 0;
	}else if(b > 255){
		b = 255;
	}
	hPen = CreatePen(PS_SOLID,1,RGB(r,g,b));
	hPObj = SelectObject(hMemDC,hPen);
#if PIXEL_SIZE > 2
	hBrush = CreateSolidBrush(RGB(r,g,b));
	hBObj = SelectObject(hMemDC,hBrush);
#endif

	rect.left = PIXEL_SIZE*x;
	rect.top = PIXEL_SIZE*y;
	rect.right = rect.left+PIXEL_SIZE;
	rect.bottom = rect.top+PIXEL_SIZE;
//	Rectangle(hMemDC,PIXEL_SIZE*x,PIXEL_SIZE*y,PIXEL_SIZE*(x+1),PIXEL_SIZE*(y+1));
	
	WaitForSingleObject(hMutex,INFINITE);
	
	Rectangle(hMemDC,rect.left,rect.top,rect.right,rect.bottom);
	
	ReleaseMutex(hMutex);

	SelectObject(hMemDC,hPObj);
	DeleteObject(hPen);
#if PIXEL_SIZE > 2
	SelectObject(hMemDC,hBObj);
	DeleteObject(hBrush);
#endif

	psetFlag = 1;
}


LRESULT CALLBACK WindowProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam){
	HDC hdc;
	PAINTSTRUCT ps;

	switch(uMsg){
	case WM_DESTROY:
		/* foCXƃrbg}bv폜 */
		DeleteDC(hMemDC);
		DeleteObject(hBitmap);
		DeleteDC(hTextDC);
		PostQuitMessage(0);
		return 0;

	case WM_CREATE:
		hdc = GetDC(hWnd);
		/* foCXƃrbg}bv쐬 */
		hMemDC = CreateCompatibleDC(hdc);
		hBitmap  = CreateCompatibleBitmap(hdc,XSIZE*PIXEL_SIZE,YSIZE*PIXEL_SIZE);
		hTextDC = CreateCompatibleDC(hdc);
		hTextmap = CreateCompatibleBitmap(hdc,XSIZE*PIXEL_SIZE,YSIZE*PIXEL_SIZE);
		ReleaseDC(hWnd,hdc);

		SelectObject(hMemDC,hBitmap);
		SelectObject(hMemDC,GetStockObject(WHITE_PEN));
		SelectObject(hMemDC,GetStockObject(WHITE_BRUSH));

		SelectObject(hTextDC,hTextmap);
		SelectObject(hTextDC,GetStockObject(WHITE_PEN));
		SelectObject(hTextDC,GetStockObject(WHITE_BRUSH));
		/* foCXɒ`` */
		Rectangle(hMemDC,0,0,XSIZE*PIXEL_SIZE,YSIZE*PIXEL_SIZE);
		Rectangle(hTextDC,0,0,XSIZE*PIXEL_SIZE,YSIZE*PIXEL_SIZE);

		/* tHg̐F̐ݒ */
		SetTextColor(hTextDC,RGB(0,0,0));
		GetTextMetrics(hTextDC,&textMetrics);

		//SelectObject(hMemDC,GetStockObject(BLACK_BRUSH));

		/* MutexIuWFNg̐ */
		hMutex = CreateMutex(NULL,FALSE,MUTEX_NAME);

		//main();
		_beginthread(startup,0,NULL);
		return 0;

	case WM_MOUSEMOVE:
		/* foCXɓ_` */
		/*
		if(GetKeyState(VK_LBUTTON) <0){
			int x=LOWORD(lParam);
			int y=HIWORD(lParam);
			Ellipse(hMemDC,x-2,y-2,x+2,y+2);
			InvalidateRect(hWnd,NULL,FALSE);
		}
		*/
		return 0;

	case WM_PAINT:
		WaitForSingleObject(hMutex,INFINITE);
		hdc = BeginPaint(hWnd,&ps);
		BitBlt(hdc,0,0,XSIZE*PIXEL_SIZE,YSIZE*PIXEL_SIZE,hMemDC,0,0,SRCCOPY);
		BitBlt(hdc,0,0,XSIZE*PIXEL_SIZE,YSIZE*PIXEL_SIZE,hTextDC,0,0,SRCAND);
		EndPaint(hWnd,&ps);
		ReleaseMutex(hMutex);
	
		return 0;

	default:
		if(psetFlag){
			psetFlag = 0;
			InvalidateRect(hWnd , NULL , 0);
		}
	}
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,PSTR lpCmdLine,int nCmdShow){
	WNDCLASS wc;
	MSG msg;

	psetFlag = 0;

	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = WindowProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon = LoadIcon(NULL,IDI_APPLICATION);
	wc.hCursor = LoadCursor(NULL,IDC_ARROW);
	wc.hbrBackground = GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName = NULL;
	wc.lpszClassName = APP_NAME;
	
	if(!RegisterClass(&wc)){
		return 0;
	}

	if((hWnd = CreateWindow(
		APP_NAME,TEXT(__FILE__),
		(WS_OVERLAPPEDWINDOW ^ WS_THICKFRAME ^ WS_MAXIMIZEBOX) | WS_VISIBLE,
		CW_USEDEFAULT,CW_USEDEFAULT,
		(XSIZE*PIXEL_SIZE)+4,(YSIZE*PIXEL_SIZE)+30,
		NULL,NULL,hInstance,NULL)) == NULL){
		return 0;
	}

	while(GetMessage(&msg,NULL,0,0) > 0){
		DispatchMessage(&msg);
	}

	return msg.wParam;
}

void startup(void *dummy){
	main();
	InvalidateRect(hWnd , NULL , 0);
}
